Package uk.ac.starlink.table.join

# Class ErrorCartesianMatchEngine

java.lang.Object
uk.ac.starlink.table.join.AbstractCartesianMatchEngine
uk.ac.starlink.table.join.ErrorCartesianMatchEngine

All Implemented Interfaces:
  `MatchEngine`

public class ErrorCartesianMatchEngine extends AbstractCartesianMatchEngine
Match Engine which works in an N-dimensional Cartesian space with isotropic per-row errors. Tuples are N+1 element, with the last element being the error radius, so that a match results when the distance between two objects is no greater than the sum of their error radii.

Since:
  1 Sep 2011
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`ErrorCartesianMatchEngine(int ndim, double scale)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method.
`double`
`getScale()`
Returns the distance scale.
`double`
`getScoreScale()`
Returns unity.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`void`
`setScale(double scale)`
Sets the distance scale, which should be roughly the average of per-object error distance This is just used in conjunction with the bin factor for tuning.
`String`
`toString()`

### Methods inherited from class uk.ac.starlink.table.join.AbstractCartesianMatchEngine

`getBinFactor, getIsotropicScale, getNdim, getScale, getTuningParameters, setBinFactor, setIsotropicScale, setScale`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ErrorCartesianMatchEngine

public ErrorCartesianMatchEngine(int ndim, double scale)
Constructor.

Parameters:
  `ndim` - dimensionality
  `scale` - rough scale of errors

## Method Details

### setScale

public void setScale(double scale)
Sets the distance scale, which should be roughly the average of per-object error distance This is just used in conjunction with the bin factor for tuning.

Parameters:
  `scale` - characteristic scale of errors

### getScale

public double getScale()
Returns the distance scale.

Returns:
  characteristic scale of errors

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(java.lang.Object)` on the returned objects.

Returns:
  array of described values which influence the match

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Description copied from interface: `MatchEngine`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Returns:
  metadata for the match score results

### toString

public String toString()

Specified by:
  `toString` in class `AbstractCartesianMatchEngine`

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Description copied from interface: `MatchEngine`
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Returns:
  supplier of coverage objects, or null

### getScoreScale

public double getScoreScale()
Returns unity.

Returns:
  scale of successful match scores, a positive finite number or NaN